execute as @e[tag=rngstand] at @s run setblock ~ ~ ~ air
execute as @e[tag=rngstand,limit=1,sort=random] at @s run setblock ~ ~ ~ redstone_block
scoreboard players add @s acttimer1 1
scoreboard players add @s acttimer2 1
scoreboard players add @s[scores={rng=3..20}] acttimer3 1
scoreboard players add @s[scores={rng=0..17}] acttimer4 1
scoreboard players add @s[scores={rng=1..7}] acttimer1 2
scoreboard players add @s[scores={rng=7..8}] acttimer1 15
scoreboard players add @s[scores={rng=12..20}] acttimer2 1
scoreboard players add @s[scores={rng=11..12,acttimer2=..760}] acttimer2 20
effect give @a[tag=!testing] blindness 7 0 true

execute as @e[tag=monster] at @s if block ~ ~ ~ cobweb run function jti:monster_tp
execute as @a[scores={immunity=0}] at @s if block ~ ~ ~ cobweb run effect give @s resistance 2 0 true
execute as @a[scores={immunity=0}] at @s if block ~ ~ ~ cobweb run effect give @s instant_damage 1 0 true
execute as @a[scores={immunity=0}] at @s if block ~ ~ ~ cobweb run playsound minecraft:enchant.thorns.hit master @s ~ ~ ~ 10000
execute as @a[scores={immunity=0}] at @s if block ~ ~ ~ cobweb run function jti:hurt
execute as @a[scores={immunity=0}] at @s if block ~ ~1.75 ~ cobweb run effect give @s resistance 2 0 true
execute as @a[scores={immunity=0}] at @s if block ~ ~1.75 ~ cobweb run effect give @s instant_damage 1 0 true
execute as @a[scores={immunity=0}] at @s if block ~ ~1.75 ~ cobweb run playsound minecraft:enchant.thorns.hit master @s ~ ~ ~ 10000
execute as @a[scores={immunity=0}] at @s if block ~ ~1.75 ~ cobweb run function jti:hurt
execute if entity @s[scores={acttimer1=1300..}] unless entity @a[x=-27,y=4,z=-11,dx=23,dy=2,dz=50] run function jti:monster_tp
execute if entity @s[scores={acttimer2=795..}] unless entity @e[tag=envstand] run summon armor_stand ~ ~10 ~ {NoGravity:1b,Silent:1b,Invulnerable:1b,Invisible:1b,PersistenceRequired:1b,Tags:["envstand"]}
execute if entity @s[scores={acttimer2=795..799}] run spreadplayers -39 11 10 40 false @e[tag=envstand]
execute as @e[tag=envstand] at @s if entity @e[tag=sv,scores={acttimer2=800..}] run function jti:create_ambience
execute as @a at @s if entity @e[tag=sv,scores={acttimer2=300,rng=1}] run playsound minecraft:custom.monster.laugh master @a[scores={chased=0}] ^ ^ ^-6 1
execute as @e[tag=monster] at @s if entity @e[tag=sv,scores={acttimer2=300,rng=2}] run playsound minecraft:custom.monster.laugh master @a[scores={chased=0}] ^ ^ ^ 1000
execute as @e[tag=monster] at @s if entity @e[tag=sv,scores={acttimer3=20..}] if entity @a[scores={chased=0}] run function jti:monster_noises
execute as @e[tag=monster] at @s if entity @e[tag=sv,scores={acttimer3=80..}] if entity @a[scores={chased=1..2}] run function jti:monster_noises
execute if entity @s[scores={acttimer4=600..,rng=10..12}] run tag @e[tag=monster,scores={vision=..0}] add stuck
execute as @e[tag=monster,scores={vision=..0}] at @s if entity @e[tag=sv,scores={acttimer4=600..,rng=1..9}] if entity @a[distance=0..6] run tag @e[tag=monster] add stuck
execute if entity @s[scores={acttimer4=600..}] run scoreboard players set @s acttimer4 0
execute if entity @s[scores={acttimer4=180,rng=9..10}] run tag @e[tag=monster] remove stuck
execute if entity @s[scores={acttimer4=300..}] run tag @e[tag=monster] remove stuck
execute as @e[tag=monster,tag=playersee] at @s run tag @s remove stuck
effect give @e[tag=monster,tag=stuck] slowness 1 255 true
execute unless entity @a[name=Peeter100,tag=testing] run effect clear @e[tag=monster,tag=!stuck] slowness
execute if entity @a[scores={deaths=1..}] run scoreboard players set @e[tag=sv] act 6

execute if entity @a[x=-27,y=4,z=-11,dx=23,dy=2,dz=50,scores={chased=0}] unless entity @e[tag=monster,x=-27,y=4,z=-26,dx=23,dy=3,dz=60] run tp @e[tag=monster] -14 4 -23
scoreboard players add @e[type=item,tag=!dontnotify] itemtime 1
execute as @e[type=item] at @s unless entity @e[tag=!dontnotify,scores={itemtime=..2}] run particle dust 0.2 1 0.2 1 ~ ~0.5 ~ 0 0 0 0 1 force @a
execute as @e[scores={itemtime=3}] at @s run tellraw @a {"text":"Thrown items might get deleted when making or loading a save!","color":"red"}
execute as @a[x=-25,y=4,z=-25,dx=26,dy=3,dz=50] at @s run particle minecraft:campfire_cosy_smoke ~ 5 ~ 8 .8 8 0 3 normal @a
execute as @a[x=-25,y=4,z=-25,dx=26,dy=3,dz=50] at @s run particle rain -3.5 13.4 18 1.3 0 1.7 0 8 normal @a
execute as @a[nbt={SelectedItem:{tag:{cutters:1b}}}] at @s if block ~ 2 ~ yellow_concrete run effect give @s haste 1 0 true
execute as @a[nbt={SelectedItem:{tag:{cutters:1b}}},scores={hasgloves=0}] at @s if block ~ 3 ~ light_gray_concrete run effect give @s mining_fatigue 1 255 true
execute as @a[nbt={SelectedItem:{tag:{cutters:1b}}},scores={hasgloves=1}] at @s if block ~ 3 ~ light_gray_concrete run effect give @s mining_fatigue 1 1 true
execute if entity @a[nbt={Inventory:[{Slot:-106b}]}] run execute as @a at @s run summon item ~ ~ ~ {Tags:["itemoffhand","dontnotify"],Item:{id:"minecraft:barrier",Count:1b}}
execute if entity @a[nbt={Inventory:[{Slot:-106b}]}] run data modify entity @e[tag=itemoffhand,limit=1] Item set from entity @p Inventory.[{Slot:-106b}]
execute if entity @a[nbt={Inventory:[{Slot:-106b}]}] run tellraw @a {"text":"You cannot use the offhand! Item dropped.","color":"yellow"}
execute if entity @a[nbt={Inventory:[{Slot:-106b}]}] run replaceitem entity @p weapon.offhand air

execute as @a[scores={rc=1..},nbt={SelectedItem:{tag:{gloves:1b}}}] at @s run title @a actionbar {"text":"Equipped gloves","color":"green"}
execute as @a[scores={rc=1..},nbt={SelectedItem:{tag:{gloves:1b}}}] at @s run playsound minecraft:item.armor.equip_leather master @s ~ ~ ~
execute as @a[scores={rc=1..},nbt={SelectedItem:{tag:{gloves:1b}}}] at @s run scoreboard players set @a hasgloves 1
execute as @a[scores={rc=1..},nbt={SelectedItem:{tag:{gloves:1b}}}] at @s run effect clear @s mining_fatigue
execute as @a[scores={rc=1..},nbt={SelectedItem:{tag:{gloves:1b}}}] at @s run clear @s carrot_on_a_stick{gloves:1b}

# MONSTER AI
scoreboard players remove @a[scores={immunity=1..}] immunity 1
execute as @e[tag=monster] at @s unless entity @e[tag=monsterray] run summon area_effect_cloud ~ ~1 ~ {NoGravity:1b,Duration:500,DurationOnUse:0f,Tags:["monsterray"]}
execute as @a[scores={chased=0}] at @s if entity @e[tag=monster,distance=0..7] unless entity @e[tag=playerray] anchored eyes run summon area_effect_cloud ^ ^ ^-1 {NoGravity:1b,Duration:500,DurationOnUse:0f,Tags:["playerray"],Particle:"nautilus"}
execute as @e[tag=monster,tag=!playersee] at @s run scoreboard players remove @s[scores={vision=0..}] vision 1
execute if entity @a[scores={chased=1..2}] if entity @e[tag=monster,scores={vision=-1..50}] run scoreboard players set @a chased 0
execute as @a[scores={chased=1..2}] at @s unless entity @e[tag=monster,distance=0..20] run scoreboard players set @a chased 0
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=monsterray] at @s run function jti:monster_vision
execute as @e[tag=playerray] at @s run tp @s ~ ~ ~ facing entity @p eyes
execute as @e[tag=playerray] at @s run tp @s ^ ^ ^1
execute as @e[tag=playerray] at @s run function jti:player_vision
execute as @e[tag=playerray] at @s run function jti:player_vision
execute as @e[tag=playerray] at @s run function jti:player_vision
execute as @e[tag=playerray] at @s run function jti:player_vision
execute as @e[tag=playerray] at @s run function jti:player_vision
kill @e[tag=playerray]
execute as @a[scores={chased=1..2}] at @s if entity @e[tag=sv,scores={rng=1..7}] run title @s actionbar {"text":"[!] RUN [!]","color":"red"}
execute as @a[scores={chased=1..2}] at @s if entity @e[tag=sv,scores={rng=8..14}] run title @s actionbar {"text":"[!] RUN [!]","color":"gold"}
execute as @a[scores={chased=1..2}] at @s if entity @e[tag=sv,scores={rng=15..20}] run title @s actionbar {"text":"[!] RUN [!]","color":"yellow"}
execute as @a[scores={chased=1..2}] at @s run effect give @s speed 1 3 true
execute as @a[scores={chased=0}] at @s if entity @s[nbt={ActiveEffects:[{Id:1b,Duration:13}]}] run playsound minecraft:custom.player.breath master @s ~ ~ ~ 1 0.98
execute as @a[scores={chased=0}] at @s if entity @s[nbt={ActiveEffects:[{Id:1b,Duration:13}]}] run effect give @s slowness 2 1 true
execute as @a[scores={chased=0}] at @s if entity @s[nbt={ActiveEffects:[{Id:1b,Duration:13}]}] run effect clear @s speed
#execute as @e[tag=monster] at @s if entity @a[scores={immunity=0},distance=0..1] run effect give @a resistance 2 0 true
#execute as @e[tag=monster] at @s if entity @a[scores={immunity=0},distance=0..1] run effect give @a instant_damage 1 1 true
#execute as @e[tag=monster] at @s if entity @a[scores={immunity=0},distance=0..1] run execute as @a at @s run playsound minecraft:custom.player.stab master @s ~ ~ ~
#execute as @e[tag=monster] at @s if entity @a[scores={immunity=0},distance=0..1] run scoreboard players set @a chased 2
#execute as @e[tag=monster] at @s if entity @a[scores={immunity=0},distance=0..1] run execute as @a at @s run function jti:hurt
tag @a remove closesee
execute if entity @a[scores={chased=2}] run scoreboard players add @s loudtimer 1
execute if entity @s[scores={loudtimer=4..}] run execute as @e[tag=monster] at @s run playsound minecraft:custom.monster.chase master @a ~ ~ ~ 2
execute if entity @s[scores={loudtimer=4..}] run scoreboard players set @s loudtimer 0
execute as @e[tag=monster] at @s run particle smoke ~ ~1 ~ .3 .5 .3 0 20 force @a

execute if entity @a[x=-47,y=5,z=-69,dx=10,dy=3,dz=1] run function jti:switch_act
execute if entity @e[tag=gunframe,nbt=!{ItemRotation:0b}] run function jti:switch_act
execute if entity @e[tag=gunframe,nbt=!{ItemRotation:0b}] run scoreboard players set @e[tag=sv] acttimer1 1

# KEYS
execute as @a[scores={rc=1..},nbt={SelectedItem:{tag:{librarykey:1b}}}] at @s run execute as @e[tag=keystand,tag=library] at @s positioned ~ ~-2 ~ if entity @a[distance=0..2] run function jti:door_toggle
execute as @a[scores={rc=1..},nbt={SelectedItem:{tag:{basementkey:1b}}}] at @s run execute as @e[tag=keystand,tag=basement] at @s positioned ~ ~-2 ~ if entity @a[distance=0..2] run function jti:door_toggle
execute as @a[scores={rc=1..},nbt={SelectedItem:{tag:{oldhousekey:1b}}}] at @s run execute as @e[tag=keystand,tag=oldhouse] at @s positioned ~ ~-2 ~ if entity @a[distance=0..2] run function jti:door_toggle
execute as @a[scores={rc=1..},nbt={SelectedItem:{tag:{shortcutkey:1b}}}] at @s positioned ~ ~2 ~ if entity @e[tag=keystand,tag=shortcut,distance=0..2] run execute as @e[tag=keystand,tag=shortcut] at @s positioned ~ ~-2 ~ run function jti:door_toggle
execute as @a[scores={rc=1..},nbt={SelectedItem:{tag:{stairskey:1b}}}] at @s run execute as @e[tag=keystand,tag=stairs] at @s positioned ~ ~-2 ~ if entity @a[distance=0..2] run function jti:door_toggle
execute as @a[scores={rc=1..},nbt={SelectedItem:{tag:{storagekey:1b}}}] at @s run execute as @e[tag=keystand,tag=storage] at @s positioned ~ ~-2 ~ if entity @a[distance=0..2] run function jti:door_toggle
execute as @a[scores={rc=1..},nbt={SelectedItem:{tag:{storage2key:1b}}}] at @s run execute as @e[tag=keystand,tag=storage2] at @s positioned ~ ~-2 ~ if entity @a[distance=0..2] run function jti:door_toggle
execute as @a[scores={rc=1..},nbt={SelectedItem:{tag:{weaponkey:1b}}}] at @s run execute as @e[tag=keystand,tag=weapon] at @s positioned ~ ~-2 ~ if entity @a[distance=0..2] run function jti:door_toggle
execute as @a[scores={rc=1..},nbt={SelectedItem:{tag:{officekey:1b}}}] at @s run execute as @e[tag=keystand,tag=office] at @s positioned ~ ~-2 ~ if entity @a[distance=0..2] run function jti:door_toggle
execute as @a[scores={rc=1..},nbt={SelectedItem:{tag:{key:1b}}}] at @s run title @s actionbar {"text":"Wrong key or too far away!","color":"white"}
scoreboard players set @a rc 0


# SAVING
execute as @a at @s if data block -56 8 0 {Book:{tag:{savebook:1b}}} unless entity @s[scores={chased=1..}] unless entity @e[tag=monster,distance=0..7] run function jti:game_save
execute as @a at @s if data block -56 8 0 {Book:{tag:{savebook:1b}}} unless entity @s[scores={chased=1..}] unless entity @e[tag=monster,distance=0..7] run tellraw @a {"text":"Game saved!","color":"green"}
execute as @a at @s if data block -56 8 0 {Book:{tag:{savebook:1b}}} unless entity @s[scores={chased=1..}] unless entity @e[tag=monster,distance=0..7] run scoreboard players set @e[tag=sv] hassave 1
execute as @a at @s if data block -56 8 0 {Book:{tag:{savebook:1b}}} unless entity @s[scores={chased=1..}] unless entity @e[tag=monster,distance=0..7] run data merge block -56 8 0 {Book:{id:"minecraft:written_book",Count:1b,tag:{savebook:2b,title:"f",author:"f",pages:['[{"text":"You can\'t take this book out for infinite saves. Sorry! :)\\n\\nClick "},{"text":"here","color":"red","bold":true,"underlined":true,"clickEvent":{"action":"run_command","value":"/function jti:erase"}},{"text":" to erase this book, so you can put a new one in."}]']}}}
execute as @a at @s if data block -56 8 0 {Book:{tag:{savebook:1b}}} run title @a title {"text":"Get to safety first!","color":"red"}
execute as @a at @s if data block -56 8 0 {Book:{tag:{savebook:1b}}} run setblock -56 8 0 air destroy
execute if block -56 8 0 air run setblock -56 8 0 lectern[facing=south]